var div_setting,div_cr,div_prv_m,div_prv_y,div_nxt_m,div_nxt_y;
var arr_holiday = new Array();
var arr_weather = new Array();
var cr_year,cr_month,cr_day;
var disp_year,disp_month,disp_day;
var start_day;
var trans_name=new Array("fade","slide","flip","cube","blur","rotate","rotate2");
var cal_name=new Array("cal_prev_y","cal_prev_m","cal_next_m","cal_next_y");
var vpf=new Array("","-moz-","-webkit-","-o-","-ms-");
var trans_menu;
var trans_num;

function init() {
  var today=new Date();
  cr_year=today.getFullYear();
  cr_month=today.getMonth();
  cr_day=today.getDate();
  div_calendar=document.getElementById("ls_calendar");
  div_setting=document.getElementById("cal_setting");
  div_cr=document.getElementById("cal_current");
  div_disp=document.getElementById("cal_display");
  div_prev_y=document.getElementById("cal_prev_y");
  div_prev_m=document.getElementById("cal_prev_m");
  div_next_m=document.getElementById("cal_next_m");
  div_next_y=document.getElementById("cal_next_y");
  div_buttons=document.getElementById("buttons");
  div_btn_setting=document.getElementById("btn_setting");
  
  var url="http://ical.mac.com/ical/Japanese32Holidays.ics";
	var httpRequest = new XMLHttpRequest();
	httpRequest.open("GET", url);
	httpRequest.overrideMimeType("text/calendar");
  httpRequest.setRequestHeader('Cache-Control', 'no-cache');
	httpRequest.send(null);
	httpRequest.onload = function() {holiday_responded(httpRequest);}

}
function holiday_responded (request) {
  var resData = request.responseText;
  var split_Data = resData.split("UID");
  for (var i=1; i < split_Data.length; i++) {
    data_index = split_Data[i].substring(split_Data[i].indexOf("DATE")+5,split_Data[i].indexOf("DTEND")-1);
    data_value = split_Data[i].substring(split_Data[i].indexOf("SUMMARY")+8,split_Data[i].indexOf("RESOURCES")-1);
    arr_holiday[data_index] = data_value;
  }
  weather_init();
}
function weather_init(){
  var url="http://rss.rssad.jp/rss/tenki/forecast/city_60.xml";
  var httpRequest = new XMLHttpRequest();
  
  httpRequest.open("GET", url);
  httpRequest.overrideMimeType("text/xml");
  httpRequest.setRequestHeader('Cache-Control', 'no-cache');
  httpRequest.send(null);
  httpRequest.onload = function() {weather_responded(httpRequest);}
}
function findChild (element, nodeName){
  var child;
	
  for (child = element.firstChild; child != null; child = child.nextSibling){
    if (child.nodeName == nodeName) return child;
  }
	
  return null;
}
function weather_responded (request) {
  var rss = findChild(request.responseXML, "rss");
  var channel = findChild(rss, "channel");
  
  var forecast, date, day, max, min, image, title, url;
  var tag_item = request.responseXML.getElementsByTagName("item");
  for (var i = 0; i < tag_item.length; i++) {
    forecast = findChild(tag_item[i], "title").textContent;
    image = findChild(tag_item[i], "image");
    url = findChild(image, "url").textContent;
    
    var dt = new Date(cr_year,cr_month,cr_day);
    var baseSec = dt.getTime();
    var targetSec = baseSec + 60*60*24*1000*i;
    dt.setTime(targetSec);
    var temp_year = dt.getFullYear();
    var temp_month = dt.getMonth();
    var temp_date = dt.getDate();
    
    arr_weather[temp_year*10000+temp_month*100+temp_date] = url;
  }

  disp_year=cr_year;
  disp_month=cr_month;
  disp_day=cr_day;
  
  var temp_cookie = getCookie("ls_calendar_transition");
  if( temp_cookie == "" || isNaN(temp_cookie) ){
    trans_menu = 0;
  }else{
    trans_menu = Number(getCookie("ls_calendar_transition"));
  }
  var temp_cookie = getCookie("ls_calendar_start_day");
  if( temp_cookie == "" || isNaN(temp_cookie) ){
    start_day = 0;
  }else{
    start_day = Number(getCookie("ls_calendar_start_day"));
  }
  
//  trans_menu = 3;
  css_load();
  display_calendar(disp_year,disp_month,disp_day);
}

function css_load() {
  if( trans_menu == 0){   //FADE
    document.getElementById("transition_css").href = "./fade.css";
    trans_name = "fade_";
  }
  if( trans_menu == 1){   //SLIDE
    document.getElementById("transition_css").href = "./slide.css";
    trans_name = "slide_";
  }
  if( trans_menu == 2){   //FLIP
    document.getElementById("transition_css").href = "./flip.css";
    trans_name = "flip_";
  }
  if( trans_menu == 3){   //CUBE
    document.getElementById("transition_css").href = "./cube.css";
    trans_name = "cube_";
  }
  if( trans_menu == 4){   //BLUR
    document.getElementById("transition_css").href = "./blur.css";
    trans_name = "blur_";
  }
  if( trans_menu == 5){   //ROTATE
    document.getElementById("transition_css").href = "./rotate.css";
    trans_name = "rotate_";
  }
  if( trans_menu == 6){   //ROTATE2
    document.getElementById("transition_css").href = "./rotate2.css";
    trans_name = "rotate2_";
  }
}

function display_calendar(year,month,day) {
	div_cr.innerHTML = make_calendar(cr_year,cr_month,cr_day);//現在_カレンダー
	div_disp.innerHTML = make_calendar(year,month,day);//表示用_カレンダー
  div_disp.className = trans_name + "stay";
  div_calendar.className = trans_name + "stay";
  document.getElementById("area_calendar").className = "";
  div_cr.className = trans_name + "stay";
  div_setting.className = trans_name + "stay";
  div_prev_y.className = trans_name + "stay";
  div_prev_m.className = trans_name + "stay";
  div_next_m.className = trans_name + "stay";
  div_next_y.className = trans_name + "stay";
	div_prev_y.innerHTML = make_calendar(year-1,month,day);//前年_カレンダー
	div_prev_m.innerHTML = make_calendar(year-(month==0),(month+11)%12,day);//前月_カレンダー
	div_next_m.innerHTML = make_calendar(year+(month==11),(month+1)%12,day);//翌月_カレンダー
	div_next_y.innerHTML = make_calendar(year+1,month,day);//翌年_カレンダー
  document.getElementById("btn_current").onclick = new Function("transition_today("+cr_year+","+cr_month+","+cr_day+","+start_day+")");//現在_ボタン
  document.getElementById("btn_prev_y").onclick =
  			new Function("transition_calendar("+(year-1)+","+month+","+day+",div_prev_y,0)");//前年_ボタン
  document.getElementById("btn_prev_m").onclick =
  			new Function("transition_calendar("+(year-(month==0))+","+(month+11)%12+","+day+",div_prev_m,1)");//前月_ボタン
  document.getElementById("btn_next_m").onclick =
  			new Function("transition_calendar("+(year+(month==11))+","+(month+1)%12+","+day+",div_next_m,2)");//翌月_ボタン
  document.getElementById("btn_next_y").onclick =
  			new Function("transition_calendar("+(year+1)+","+month+","+day+",div_next_y,3)");//翌年_ボタン
  document.getElementById("btn_setting").onclick = new Function("setting_show()");//設定_ボタン
  div_buttons.className = "on";
  
    for (i=0; i < 7; i++){
      document.getElementById("day_"+i).onclick = new Function("transition_today("+disp_year+","+disp_month+","+disp_day+","+(start_day+i)%7+")");//曜日_ボタン
    }
}

function transition_calendar(year,month,day,trans_id,cal_id) {
  

  var str;
  if( trans_menu == 0) {	//fade
  	div_disp.className = "fade_off";
  	trans_id.className = "fade_on";
    div_buttons.className = "off";
  }
  if( trans_menu == 1) {	//slide
  	div_disp.className = "slide_on" + " " + cal_name[cal_id];
  	trans_id.className = "slide_on";
    div_buttons.className = "off";
  }
  if( trans_menu == 2) {	//flip
  	div_disp.className = "flip_on" + " " + cal_name[cal_id];
  	trans_id.className = "flip_on";
    div_buttons.className = "off";
  }
  if( trans_menu == 3) {	//cube
  	div_disp.className = "cube_on";
  	div_calendar.className = "cube_on" + " " + cal_name[cal_id];
    div_buttons.className = "off";
  }
  if( trans_menu == 4) {	//blur
  	div_disp.className = "blur_off";
  	trans_id.className = "blur_on";
    div_buttons.className = "off";
  }
  if( trans_menu == 5) {	//rotate
  	div_disp.className = "rotate_on";
  	div_calendar.className = "rotate_on" + " " + cal_name[cal_id];
  	trans_id.className = "rotate_on" + " " + cal_name[cal_id] + "_on";
    div_buttons.className = "off";
  }
  if( trans_menu == 6) {	//rotate2
  	div_disp.className = "rotate2_on" + " " + cal_name[cal_id] + "_on";
  	div_calendar.className = "rotate2_on" + " " + cal_name[cal_id];
  	trans_id.className = "rotate2_on";
    div_buttons.className = "off";
  }
  
//  div_buttons.className = "off";

  disp_year=year;
  disp_month=month;
  disp_day=day;
  div_disp.addEventListener(
                                'webkitTransitionEnd',
                                transition_end_calendar,
                                false
                                );
}
function transition_end_calendar() {
  div_disp.removeEventListener(
                                   'webkitTransitionEnd',
                                   transition_end_calendar,
                                   false
                                   );
    
  display_calendar(disp_year,disp_month,disp_day);
}

function transition_today(year,month,day,s_day) {
  start_day = s_day
	div_cr.innerHTML = make_calendar(year,month,day);//現在_カレンダー
  document.getElementById("area_calendar").className = "today_on";
  document.getElementById("cal_prev_y").className = "today_on";
  document.getElementById("cal_prev_m").className = "today_on";
  document.getElementById("cal_next_m").className = "today_on";
  document.getElementById("cal_next_y").className = "today_on";
  div_disp.className = "today_on";
  div_buttons.className = "today_on";
  div_cr.className = "today_on";
  disp_year=year;
  disp_month=month;
  disp_day=day;
  div_cr.addEventListener(
                                'webkitTransitionEnd',
                                transition_end_today,
                                false
                                );
  div_buttons.className = "off";
  var tmp = "ls_calendar_start_day=" + start_day + "; ";
  tmp += "expires=Tue, 31-Dec-2030 23:59:59; path=/";
  document.cookie = tmp;
}
function transition_end_today() {
  div_cr.removeEventListener(
                                  'webkitTransitionEnd',
                                  transition_end_today,
                                  false
                                  );
  document.getElementById("area_calendar").className = "today_off";
  div_cr.className = "today_off";
  div_disp.className = "today_off";
  display_calendar(disp_year,disp_month,disp_day);
}

function setting_show() {
  document.getElementById("area_calendar").className = "setting_on";
  document.getElementById("cal_prev_y").className = "setting_on";
  document.getElementById("cal_prev_m").className = "setting_on";
  document.getElementById("cal_next_m").className = "setting_on";
  document.getElementById("cal_next_y").className = "setting_on";
  div_btn_setting=document.getElementById("btn_setting").className = "setting_on";
  div_disp.className = "setting_on";
  div_buttons.className = "setting_on";
  div_setting.className = "setting_on";

  document.getElementById("btn_prev_y").onclick = new Function("");//前年_ボタン
  document.getElementById("btn_prev_m").onclick = new Function("");//前月_ボタン
  document.getElementById("btn_next_m").onclick = new Function("");//翌月_ボタン
  document.getElementById("btn_next_y").onclick = new Function("");//翌年_ボタン
  document.getElementById("btn_next_y").onclick = new Function("");//本日_ボタン
  for (i=0; i < 7; i++){
    document.getElementById("day_"+i).onclick = new Function("");//曜日_ボタン
  }

  document.getElementsByName("transition_name")[Number(getCookie("ls_calendar_transition"))].checked = true;
}
function setting_save() {
  var nodeList = document.getElementsByName("transition_name");
  for (var i = 0; i < nodeList.length; i++) {
    if(nodeList[i].checked == true ) break;
  }
  var tmp = "ls_calendar_transition=" + i + "; ";
  tmp += "expires=Tue, 31-Dec-2030 23:59:59; path=/";
  document.cookie = tmp;
  trans_menu = i;
  setting_hide();
}
function setting_hide() {
  document.getElementById("area_calendar").className = "setting_off";
  document.getElementById("cal_prev_y").className = "setting_off";
  document.getElementById("cal_prev_m").className = "setting_off";
  document.getElementById("cal_next_m").className = "setting_off";
  document.getElementById("cal_next_y").className = "setting_off";
  div_btn_setting=document.getElementById("btn_setting").className = "setting_off";
  div_disp.className = "setting_off";
  div_buttons.className = "setting_off";
  div_setting.className = "setting_off";
  div_cr.className = "setting_off";

  div_setting.addEventListener(
                                'webkitTransitionEnd',
                                transition_end_setting,
                                false
                                );
    css_load();

}
function transition_end_setting() {
  div_setting.removeEventListener(
                               'webkitTransitionEnd',
                               transition_end_setting,
                               false
                               );
  display_calendar(disp_year,disp_month,disp_day);
}
function getCookie(key,  tmp1, tmp2, xx1, xx2, xx3) {
  tmp1 = " " + document.cookie + ";";
  xx1 = xx2 = 0;
  len = tmp1.length;
  while (xx1 < len) {
    xx2 = tmp1.indexOf(";", xx1);
    tmp2 = tmp1.substring(xx1 + 1, xx2);
    xx3 = tmp2.indexOf("=");
    if (tmp2.substring(0, xx3) == key) {
      return(unescape(tmp2.substring(xx3 + 1, xx2 - xx1 - 1)));
    }
    xx1 = xx2 + 1;
  }
  return("");
}

//start_day = 4;
function make_calendar(year,month,day) {
  var leap_year=((year%4 == 0 && year%100 != 0) || (year%400 == 0));
  ary_month=new Array(31,28+leap_year,31,30,31,30,31,31,30,31,30,31);
  ary_day=new Array("日","月","火","水","木","金","土");
  var days=0;
  for (var i=0; i < month; i++){
		days+=ary_month[i];
  }
  var week=Math.floor((year*365.2425+days)%7);
  var j;
  var k;
  var calendar="<table>\n";
  calendar+='<tr><td class="td_caption" colspan="7">';
  calendar+='<p id="p_caption">' +year+"年 "+(month+1)+"月" + "</p>";
  calendar+= "</td></tr>\n";
  calendar+="<tr>";
  for (i=start_day; i < 7+start_day; i++){
		calendar+='<td class="day';
		if (i%7 == 0){
	    calendar+=' sun';
		}
		if (i == 6){
	    calendar+=' sat';
		}
		calendar+='">'+ary_day[i%7]+"</td>";
  }
  calendar+="</tr>\n<tr>";
  j = 1;
  for (i=0; i < (week+7-start_day)%7; i++){
		k=ary_month[(month+11)%12]-(week+7-start_day)%7+i+1;
		calendar+='<td class="blank"'
		if (year == cr_year && (month+11)%12 == cr_month && day == k){
	    calendar+=' id="today"';
		}
    weather_url = arr_weather[year*10000+((month+11)%12)*100+k];
		if (typeof weather_url != "undefined"){
	    calendar+='><div class="weather"><img src="';
	    calendar+=weather_url;
	    calendar+='"/></div';
		}
		calendar+='>' + k + '</td>';
		j++;
  }
  for (i=1; i <= ary_month[month]; i++) {
		holiday = arr_holiday[year*10000+(month+1)*100+i];//データの月に合わせるため１を足す
		calendar+="<td";
		if (year == cr_year && month == cr_month && day == i && 0 < day){
	    calendar+=' id="today"';
		}
		if (typeof holiday != "undefined"){
	    calendar+=' class="sun"';
		}
		else if (j == (7-start_day)%7+1 ){
	    calendar+=' class="sun"';
		}
		else if (j == (7-start_day) ){
	    calendar+=' class="sat"';
		}
    weather_url = arr_weather[year*10000+month*100+i];
		if (typeof weather_url != "undefined"){
	    calendar+='><div class="weather"><img src="';
	    calendar+=weather_url;
	    calendar+='"/></div';
		}
		calendar+=">"+i;
		if (typeof holiday != "undefined"){
		calendar+='<p class="';
		if (holiday.length == 5){
		  calendar+="holiday5";
		}
		else if (holiday.length == 6){
		  calendar+="holiday6";
		}
		else {
		  calendar+="holiday";
		}
		calendar+='">' + holiday + '</p>';
		}
		calendar+="</td>";
		j++;
		if (j > 7) {
	    calendar+="</tr>\n<tr>";
	    j=1;
		}
  }
  k=1;
  j= j==1 ? 8:j;
  for (i=j; i <= 7; i++){
		calendar+='<td class="blank"';
    weather_url = arr_weather[year*10000+(month+1)*100+k];
		if (typeof weather_url != "undefined"){
	    calendar+='><div class="weather"><img src="';
	    calendar+=weather_url;
	    calendar+='"/></div';
		}
		calendar+='>' + k + '</td>';
		k++;
  }
  return calendar;
}
